Bug 2024924 - Review Request: python-inspyred - Library for bio-inspired computational intelligence
Summary: Review Request: python-inspyred - Library for bio-inspired computational inte...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2021-11-19 14:15 UTC by Ankur Sinha (FranciscoD)
Modified: 2021-12-03 01:32 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-12-03 01:14:35 UTC
Type: ---
zbyszek: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2021-11-19 14:15:37 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-inspyred/python-inspyred.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-inspyred/python-inspyred-1.0.1-2.20211119gitd5976ab.fc36.src.rpm

Description: 
inspyred is a free, open source framework for creating biologically-inspired
computational intelligence algorithms in Python, including evolutionary
computation, swarm intelligence, and immunocomputing. Additionally, inspyred
provides easy-to-use canonical versions of many bio-inspired algorithms for
users who do not need much customization.

Fedora Account System Username: ankursinha

Comment 1 Zbigniew Jędrzejewski-Szmek 2021-11-19 17:38:06 UTC
+ package name is OK
+ license is acceptable for Fedora (MIT)
+ license is specified correctly
+ builds and installs OK
+ standard python template is used, so not much to review here
+ latest version (from 2015 :( )
+ fedora-review is happy (except for a bogus complaint about missing dist tag in %autorelease)
+ BR/R/P look OK

I wouldn't bother with the separate -doc subpackage, it's only 16kb.

Package is APPROVED.

Comment 2 Ankur Sinha (FranciscoD) 2021-11-19 19:03:29 UTC
Thanks Zbigniew!

Yeh, I'm going to drop upstream a ticket letting them know that it seems to work on py3.10 too, and hopefully we'll get a new release :D

I'll go request SCM now, and drop the -doc sub-package before review.

Cheers,
Ankur

Comment 3 Gwyn Ciesla 2021-11-19 19:11:28 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-inspyred

Comment 4 Hafsat 2021-11-19 19:49:36 UTC

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.

This is not an official review, I am a new packager and I need a sponsor.

A couple of questions I have, 
1) What does it mean that "License file installed when any subpackage combination is installed."I have checked and it's license is MIT, which is open source but I am not sure about the installation being referred to here.

2) I am not sure how to determine if a package has a bundled library, so I put a "?" there

3)How do I check that development files are in a -devel package?

4) I can see the in %doc, there is READ.rst, HISTORY.rst and CONTRIBUTING.rst and I don't think these are related to anything runtime but there is "%{_bindir}/inspyred" and I do not know if and how this affects no 51 of the review

5) Why is the %{forgeurl} and %{forgesource} in the source0 and url?

6) I don't understand no 63, how to check if large documentation goes in a -doc subpackage?

7) How do I check if the source package includes the text of the License? Is that the licensecheck.txt? Also didn't see %license in the spec file or is the license field, above the URL?

8) How can you check if the package functions as described?

9) How can I verify the sources with gpgverify?

10) How do I check if Python eggs downloaded any dependencies during the build process?

11) It has %check but the build.log contains no information about tests carried out, so how do I know if the tests have been passed? DO I run a fedpkg mockbuild? I ran the rpmlint on the srpm and it passed, I am not sure if that matters?

I tried to do an intensive review so I have a better idea of other reviews....thank you for the platform.



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License", "*No copyright* [generated file]". 95 files have unknown
     license. Detailed output of licensecheck in
     /home/hafsat/Documents/outreachy/neuroFedora/reviews/2024924-python-
     inspyred/licensecheck.txt
[?]: License file installed when any subpackage combination is installed.
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[?]: Development files must be in a -devel package
[?]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[?]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[?]: Python eggs must not download any dependencies during the build
     process.
[?]: A package which is used by another package via an egg interface should
     provide egg info.
[]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[?]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-inspyred
[?]: Package functions as described.
[x]: Latest version is packaged.
[?]: Package does not include license text files separate from upstream.
[?]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[!]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/aarongarrett/inspyred/archive/d5976ab503cc9d51c6f586cbb7bb601a38c01128/inspyred-d5976ab503cc9d51c6f586cbb7bb601a38c01128.tar.gz :
  CHECKSUM(SHA256) this package     : b67820283253998a9c7544b7fb54a5505efe6c673cae0d4b53b105187725a37d
  CHECKSUM(SHA256) upstream package : b67820283253998a9c7544b7fb54a5505efe6c673cae0d4b53b105187725a37d


Requires
--------
python3-inspyred (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.10dist(click)

python-inspyred-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-inspyred:
    python-inspyred
    python3-inspyred
    python3.10-inspyred
    python3.10dist(inspyred)
    python3dist(inspyred)

python-inspyred-doc:
    python-inspyred-doc



Diff spec file in url and in SRPM
---------------------------------
--- /home/hafsat/Documents/outreachy/neuroFedora/reviews/2024924-python-inspyred/srpm/python-inspyred.spec	2021-11-19 16:16:20.481337236 +0100
+++ /home/hafsat/Documents/outreachy/neuroFedora/reviews/2024924-python-inspyred/srpm-unpacked/python-inspyred.spec	2021-11-19 15:11:42.000000000 +0100
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 2;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
 %global _description %{expand:
 inspyred is a free, open source framework for creating biologically-inspired
@@ -63,3 +72,7 @@
 
 %changelog
-%autochangelog
+* Fri Nov 19 2021 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur@gmail.com> 1.0.1-2
+- Uncommitted changes
+
+* Fri Nov 19 2021 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur@gmail.com> 1.0.1-1
+- feat: init


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2024924
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: C/C++, R, Ocaml, Java, Perl, Haskell, PHP, fonts, SugarActivity
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Ankur Sinha (FranciscoD) 2021-11-19 20:33:57 UTC
Hi Hafsat,

Thanks for the review! I'll answer your queries below:

(In reply to Hafsat from comment #4> 
> A couple of questions I have, 
> 1) What does it mean that "License file installed when any subpackage
> combination is installed."I have checked and it's license is MIT, which is
> open source but I am not sure about the installation being referred to here.

As you know, a spec can include multiple-sub packages. Sometimes more than one of them are installed simultaneously. In such cases, we need to check that whatever combination of sub-packages are installed, the license file is installed. It doesn't apply here because there's only one sub-package, and so that should include the license file.

> 
> 2) I am not sure how to determine if a package has a bundled library, so I
> put a "?" there

This requires us to check the source code. Usually, these are kept in folders called "lib" or "extra" but it varies from software to software. You'll get better at spotting these as you do more reviews.

> 
> 3)How do I check that development files are in a -devel package?

This usually applies to C/C++ software. Python modules just go into the python3- subpackage.

> 
> 4) I can see the in %doc, there is READ.rst, HISTORY.rst and
> CONTRIBUTING.rst and I don't think these are related to anything runtime but
> there is "%{_bindir}/inspyred" and I do not know if and how this affects no
> 51 of the review

if it's not on the line starting with `%doc`, it isn't being marked as documentation. So, that's fine.

> 
> 5) Why is the %{forgeurl} and %{forgesource} in the source0 and url?

These are the forge macros:
https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_using_forges_hosted_revision_control

> 
> 6) I don't understand no 63, how to check if large documentation goes in a
> -doc subpackage?

fedora-review will tell you the size of the documentation if it's not in the -doc subpackage. This is because adding large documentation to the main package will increase it's size, so we put it in the -doc sub-package so that users can install it if they wish.

> 
> 7) How do I check if the source package includes the text of the License? Is
> that the licensecheck.txt? Also didn't see %license in the spec file or is
> the license field, above the URL?

The %pyproject_save_files macro also pulls in the license file, so we don't need to mention it again in %license.
The way to check this is to use `rpm -ql --licensefiles -p <path to your rpm file>`

> 
> 8) How can you check if the package functions as described?

You install it and run some examples listed in the documentation etc. A quick check will do---the person packaging generally checks this.

> 
> 9) How can I verify the sources with gpgverify?

This is documented here. We only do this if the developers sign the sources with gpg keys (which is not often)


> 
> 10) How do I check if Python eggs downloaded any dependencies during the
> build process?

You check the build log to see if anything was downloaded. When building with mock, mock disables network for the build so this should not happen.


> 
> 11) It has %check but the build.log contains no information about tests
> carried out, so how do I know if the tests have been passed? DO I run a
> fedpkg mockbuild? I ran the rpmlint on the srpm and it passed, I am not sure
> if that matters?

hrm, that's odd. It should have the information about the tests. As you see from the spec, you'll see that we run pytest. Here's the build log for rawhide, see how pytest is run in %check:

https://kojipkgs.fedoraproject.org//packages/python-inspyred/1.0.1/4.20211119gitd5976ab.fc36/data/logs/noarch/build.log


> 
> I tried to do an intensive review so I have a better idea of other
> reviews....thank you for the platform.

That's good. This is exactly why we ask you to do reviews :)

Comment 6 Fedora Update System 2021-11-19 20:42:05 UTC
FEDORA-2021-6e0f37d0f5 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-6e0f37d0f5

Comment 7 Fedora Update System 2021-11-19 20:42:06 UTC
FEDORA-2021-e8572cb0d3 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-e8572cb0d3

Comment 8 Fedora Update System 2021-11-20 02:05:50 UTC
FEDORA-2021-6e0f37d0f5 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-6e0f37d0f5 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-6e0f37d0f5

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 9 Fedora Update System 2021-11-20 02:20:12 UTC
FEDORA-2021-e8572cb0d3 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-e8572cb0d3 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-e8572cb0d3

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-11-25 20:17:02 UTC
FEDORA-2021-a2b1150fc1 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-a2b1150fc1`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-a2b1150fc1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2021-11-25 20:17:03 UTC
FEDORA-2021-d00ae80fb8 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-d00ae80fb8`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-d00ae80fb8

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-12-03 01:14:35 UTC
FEDORA-2021-a2b1150fc1 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 13 Fedora Update System 2021-12-03 01:32:43 UTC
FEDORA-2021-d00ae80fb8 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.